<template>
  <v-card tile :to="to">
    <v-card-title
      class="header grey pa-2 pl-6 pr-6 d-flex justify-space-between"
    >
      <v-row style="width:100%">
        <v-col cols="12" class="text-truncate">
          <template v-if="loadingTitle">
            <v-skeleton-loader
              height="32"
              class="mx-auto d-flex align-center"
              type="heading"
            />
          </template>
          <template v-else>
            <template v-if="titleNotFound">
              <span class="font-weight-black white--text justify-space-between"
                >Título no encontrado</span
              >
            </template>
            <template v-else>
              <slot name="header" />
            </template>
          </template>
        </v-col>
      </v-row>
    </v-card-title>
    <v-card-text class="content pa-8 pt-4 pb-4">
      <template v-if="loadingContent">
        <v-skeleton-loader
          :type="loadingLocalContentType"
          :types="loadingContentTypes"
        />
      </template>
      <template v-else>
        <template v-if="contentNotFound">
          <div class="text-center">
            <v-avatar class="ma-3" size="100%" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="notFoundImg"
                :lazy-src="notFoundImg"
                class="white--text align-end"
                height="125"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
            <span class="font-weight-black text-h5 grey--text"
              >Información no encontrada</span
            >
          </div>
        </template>
        <template v-else>
          <slot name="content" />
        </template>
      </template>
    </v-card-text>
  </v-card>
</template>
<style scoped>
.content {
  color: black !important;
  font-size: 1.3em !important;
}
</style>
<style>
.content table tr td {
  font-size: 1em !important;
  border-bottom: none !important;
}
.content table thead {
  border-bottom: 2px solid #ffcd00;
}
</style>
<script>
export default {
  name: "Component-CardChart",
  props: {
    loadingTitle: {
      required: false,
      default: false,
      type: Boolean,
    },
    loadingContent: {
      required: false,
      default: false,
      type: Boolean,
    },
    loadingContentType: {
      required: false,
      default: "image",
      type: String,
    },
    loadingContentTypes: {
      required: false,
      default() {
        return {};
      },
      type: Object,
    },
    titleNotFound: {
      required: false,
      default: false,
      type: Boolean,
    },
    contentNotFound: {
      required: false,
      default: false,
      type: Boolean,
    },
    to: {
      required: false,
      default: null,
      type: Object,
    },
  },
  computed: {
    loadingLocalContentType() {
      if (
        this.loadingContentType &&
        this.loadingContentType === "table-with-tfoot"
      ) {
        return "table-thead, table-row-divider@3, table-tfoot";
      } else {
        return this.loadingContentType;
      }
    },
  },
  data() {
    return {
      notFoundImg: require("@/assets/img/sistema-informacion/sin-datos.svg"),
    };
  },
};
</script>
